// Q3 108061112 林靖
//
// Given a k-digit decimal integer, N = d(k)...d(1), the DigitSum is
// defined as
//
// DigitSum(N) = sum d(k)
//
// For example, N = 789, then
//  DigitSum(N) = DigitSum(789) = 7 + 8 + 9 = 24
//
// Given any integer N, a recursive function G(N) is defined as
//
// G(N) = N,              if N < 10,
//        G(DigitSum(N)), otherwise.
//
// For example, G(789) = G(24) = G(6) = 6.
//
// Given any integer, N, please write A recursive function to return
// the value of G(N).

#include <stdio.h>
#include <stdlib.h>

int G(int N)
{
	int d[10];		// the value of each degit
	long time;		// the position of each digit, 10^time
	int digit_sum;	// the sum of all the digit
	int i, j;		// temp var for looping

	if (N < 10) {	// solvable problem, end of recursion, return directly
		return N;
	}
	for (i = 9; i >= 0; i--) {	// run through each digit, from high to low
		time = 1;				// initialize
		for (j = 0; j < i; j++) {	// compute 10^time
			time *= 10;
		}
		d[i] = N / time;	// store the digit itself
		N -= d[i] * time;	// cut off the highest digit
	}
	digit_sum = 0;			// initialize
	for (i = 0; i < 9; i++) {	// sum up all the digit
		digit_sum += d[i];
	}
	return (G(digit_sum));	// trigger the recursion
}
